import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class SFServlet extends HttpServlet
{
	private PrintWriter	out;


	public void init()
	{
		return;
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
	{
		this.doPost(request, response);
	}

	/** Methode fr CGI-POST. Diese wird auf die doGet Methode
	  * weitergeleitet */
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
	{
//		HttpSession	session;
		SFServerImpl	server = null;
		String		implKey = "";
		int		res = 0;

		/* Contenttype fr output setzen */
		response.setContentType("text/html");
		/* Outputstream festhalten */
		out = response.getWriter();

/*		out.println(
			"<html><head><meta name=\"author\" content=\"Bernhard R. Fiser\">" +
			"<meta name=\"date\" content=\"2002-12-21T12:00:00+02:00\">" +
			"<title>SFDispo V0.5</title></head><body>\n");*/

		this.fputthrough(out, "pagehead.inc.html");


		if ((implKey = request.getParameter("implkey")) == null)
		{
			/* Neuer Server soll angelegt werden. */
			if (request.getParameter("new") != null)
			{
				String	name = request.getParameter("name");
				String	type_s = request.getParameter("type");
				int	type = -1;

				if (name.trim().length() == 0)
					name = null;
				if ((name != null) && (type_s != null))
				{
					try
					{
						type = Integer.parseInt(type_s);
					}
					catch (NumberFormatException e) {}

					switch (type)
					{
						/* Carrier */
						case 1 :
							type = ServerInfo.CARRIER;
							break;
						
						/* Port */
						case 2 :
							type = ServerInfo.PORT;
							break;

						/* others not implemented yet */
						default :
							type = -1;
					}
				}

				if (type != -1)
				{
					if ((server = SFServerImpl.getInstance("localhost", name, type)) == null)
					{
						out.println("<font color=\"red\"><b>Konnte keine Instanz erstellen. --&gt; <a href=\"SFServlet\">Neu starten.</a></b></font>");
					}
					else
					{
						out.print("<font color=\"green\">Neuer SFServer angelegt.</font><br>");
					}
				}
				/* Falsche Parameter -> neustart */
				else
				{
					out.println("<font color=\"red\"><b>Falsche Parameter &uuml;bergeben. --&gt; <a href=\"SFServlet\">Neu starten.</a></b></font>");
				}
			}

			out.println("<h1>Neuen DispoServer starten ...</h1>");
			this.fputthrough(out, "pagetop.inc.html");
			this.list_servers(out);
			this.fputthrough(out, "pagemid.inc.html");

			out.println(
				"<form method=\"post\" action=\"SFServlet\"><table border=\"0\">" +
				"<tr><td>Name des Unternehmens:</td><td><input type=\"text\" name=\"name\" size=\"40\" maxlength=\"128\"></td></tr>" +
				"<tr><td>Typ:</td><td><input type=\"radio\" name=\"type\" value=\"1\" checked> Reederei, <input type=\"radio\" name=\"type\" value=\"2\"> Hafen</td></tr>" +
				"<tr><td><input type=\"submit\" name=\"new\" value=\"Server starten\"></td></tr>" +
				"</table></form>");
		}
		/* Session existiert bereits. */
		else
		{
			out.println("<h1>Server: " + implKey + "</h1>");
			this.fputthrough(out, "pagetop.inc.html");
			this.list_servers(out);
			this.fputthrough(out, "pagemid.inc.html");

			if ((server = SFServerImpl.getInstanceKey(implKey)) == null)
			{
				out.println("<font color=\"red\"><b>&Uuml;ng&uuml;ltiger implKey. --&gt; <a href=\"SFServlet\">Neu starten.</a></b></font>");
			}
			else
			{
				/* Buttons fr alle Impls erzeugen. */
				out.println(
					"<h2>Allgemeine Funktionen</h2>" +
					"<form method=\"post\" action=\"SFServlet?implkey=" + implKey + "\"><table border=\"0\">" +
					"<tr><td><input type=\"submit\" name=\"info\" value=\"Server Information\"></td></tr>" +
					"<tr><td><input type=\"submit\" name=\"reload\" value=\"Seite neu laden\"></td></tr>" +
					"</table>");

				/* Informationen ber Server ausgeben. */
				if (request.getParameter("info") != null)
					server.getServerInfo().execute(out, "info", "html");

				/* Spezieller Ablauf ber CarrierImpl ausgeben. */
				if (server instanceof CarrierImpl)
				{
					this.doCarrierImpl(out, request, (CarrierImpl) server);
				}
				else if (server instanceof PortImpl)
				{
					this.doPortImpl(out, request, (PortImpl) server);
				}
				else
				{
					out.println("<font color=\"red\"><b>Noch keine Funktionen fr diesen Type implementiert.</b></font>");
				}

				/* Allgemeine Anzeigen fr alle Impls */
				out.println("<table border=\"0\"><tr valign=\"top\"><td>");
				out.println("<h3>Aktive Server</h3>");
				server.getServerMap().execute(out, "servers", "html");

				out.println("</td><td><h3>Aktuelle Frachtliste</h3>");
				server.getFreightMap().execute(out, "list", "html");
				out.println("</tr></table>");

				out.println("</form>");
			}
		}
		this.fputthrough(out, "pagefoot.inc.html");
	}

	/* Datei lesen und direkt ausgeben. */
	private void fputthrough(PrintWriter out, String fname)
	{
		String		buf;
		ReadFile	in = new ReadFile();

		fname = "/home/fiser/public_html/servlets/" + fname;
		if (in.open(fname))
		{
			while ((buf = in.readLine()) != null)
				out.println(buf);
			in.close();
		}
		else
			System.err.println("Could not open file " + fname);
	}


	/* Liste der Verfgbaren Server anzeigen. */
	private void list_servers(PrintWriter out)
	{
		int		c = 0;
		SFServerImpl	server;
		String		implKey;

		out.println("<li><a href=\"SFServlet\">Neuen Server starten</a></li>");
		Iterator i = SFServerImpl.iterator();
		while (i.hasNext())
		{
			c++;
			server = (SFServerImpl) i.next();
			implKey = server.getServerInfo().getHostname() + ":" + server.getServerInfo().getDescription() + ":" + server.getServerInfo().getType();
			out.println(
				"<li><a href=\"SFServlet?implkey=" + implKey + "\">" +
				server.getServerInfo().getDescription() + " - " +
				server.getServerInfo().getTypeStr() + " - " +
				server.getServerInfo().getSrvNum() + "</a></li>");
		}
		while (c++ < 12)
			out.println("<br>");
	}

	/* Spezielle Bearbeitung fr CarrierImpl */
	private void doCarrierImpl(PrintWriter out, HttpServletRequest request, CarrierImpl impl)
	{
		if (request.getParameter("create") != null)
		{
			if (impl.execute(out, "create", request.getParameter("desc") + " " + request.getParameter("weight") + " " + request.getParameter("value")) == Command.OK)
				out.println("<br><font color=\"green\"><b>Fracht gespeichert</b></font><br>");
			else
				out.println("<br><font color=\"red\"><b>Falsche Parameter &uuml;bergeben</b></font><br>");
		}
		if (request.getParameter("request") != null)
		{
			if (new CmdRequestPapers(impl).execute(out, "request", request.getParameter("freightmap") + " " + request.getParameter("servermap")) == Command.OK)
				out.println("<br><font color=\"green\"><b>Signature angefordert.</b></font><br>");
			else
				out.println("<br><font color=\"red\"><b>Falsche Parameter &uuml;bergeben</b></font><br>");
		}

		if (request.getParameter("announce") != null)
		{
			if (new CmdAnnounceArrival(impl).execute(out, "announce", request.getParameter("freightmap") + " " + request.getParameter("servermap")) == Command.OK)
				out.println("<br><font color=\"green\"><b>Fracht angek&uuml;ndigt.</b></font><br>");
			else
				out.println("<br><font color=\"red\"><b>Falsche Parameter &uuml;bergeben</b></font><br>");
		}

		if (request.getParameter("create_init") != null)
		{
			out.println(
				"<table border=\"0\">" +
				"<tr><td>Frachtbezeichnung:</td><td><input type=\"text\" name=\"desc\" size=\"40\" maxlength=\"128\"></td></tr>" +
				"<tr><td>Frachtgewicht (int):</td><td><input type=\"text\" name=\"weight\" size=\"10\" maxlength=\"10\"></td></tr>" +
				"<tr><td>Frachtwert (int):</td><td><input type=\"text\" name=\"value\" size=\"10\" maxlength=\"10\"></td></tr>" +
				"<tr><td><input type=\"submit\" name=\"create\" value=\"Fracht anlegen\"></td></tr>" +
				"</table>");
		}

		out.println(
			"<h2>Reederei Funktionen</h2>" +
			"<table border=\"0\">" +
			"<tr><td><input type=\"submit\" name=\"create_init\" value=\"Neue Fracht erstellen\"></td></tr>" +
			"<tr><td><input type=\"submit\" name=\"request\" value=\"Signature Anfordern\"></td><td>Dazu muss eine Fracht und eine Zollbeh&ouml;rde (customs) ausgew&auml;hlt sein.</td></tr>" +
			"<tr><td><input type=\"submit\" name=\"announce\" value=\"Ankunft der Fracht ank&uuml;ndigen\"></td><td>Dazu muss ein Fracht und ein Hafen (port) ausgew&auml;hlt sein.</td></tr>" +
			"</table>");
	}

	/* Spezielle Bearbeitung fr PortImpl */
	private void doPortImpl(PrintWriter out, HttpServletRequest request, PortImpl impl)
	{
		if (request.getParameter("setarrival") != null)
		{
			if (new CmdSetArrival(impl).execute(out, "setarrival", request.getParameter("freightmap") + " " + request.getParameter("servermap")) == Command.OK)
				out.println("<br><font color=\"green\"><b>Frachtankunft gemeldet.</b></font><br>");
			else
				out.println("<br><font color=\"red\"><b>Falsche Parameter &uuml;bergeben</b></font><br>");
		}

		out.println(
			"<h2>Hafen Funktionen</h2>" +
			"<table border=\"0\">" +
			"<tr><td><input type=\"submit\" name=\"setarrival\" value=\"Frachtankunft melden\"></td><td>Dazu muss eine Fracht und eine Zollbeh&ouml;rde (customs) ausgew&auml;hlt sein.</td></tr>" +
			"</table>");
	}
}
